## docker.io-app 26.1.3

=== Makefile ===
.PHONY: all binary dynbinary build cross help install manpages run shell test test-docker-py test-integration test-unit validate validate-% win

DOCKER ?= docker
BUILDX ?= $(DOCKER) buildx

# set the graph driver as the current graphdriver if not set
DOCKER_GRAPHDRIVER := $(if $(DOCKER_GRAPHDRIVER),$(DOCKER_GRAPHDRIVER),$(shell docker info -f '{{ .Driver }}' 2>&1))
export DOCKER_GRAPHDRIVER

DOCKER_GITCOMMIT := $(shell git rev-parse HEAD)
export DOCKER_GITCOMMIT

# allow overriding the repository and branch that validation scripts are running
# against these are used in hack/validate/.validate to check what changed in the PR.
export VALIDATE_REPO
export VALIDATE_BRANCH
export VALIDATE_ORIGIN_BRANCH

export PAGER
export GIT_PAGER

# env vars passed through directly to Docker's build scripts
# to allow things like `make KEEPBUNDLE=1 binary` easily
# `project/PACKAGERS.md` have some limited documentation of some of these
#
# DOCKER_LDFLAGS can be used to pass additional parameters to -ldflags
# option of "go build". For example, a built-in graphdriver priority list
# can be changed during build time like this:
#
# make DOCKER_LDFLAGS="-X github.com/docker/docker/daemon/graphdriver.priority=overlay2,zfs" dynbinary
#
DOCKER_ENVS := \
	-e BUILDFLAGS \
	-e KEEPBUNDLE \
	-e DOCKER_BUILD_ARGS \
	-e DOCKER_BUILD_GOGC \
	-e DOCKER_BUILD_OPTS \
	-e DOCKER_BUILD_PKGS \
	-e DOCKER_BUILDKIT \
	-e DOCKER_BASH_COMPLETION_PATH \
	-e DOCKER_CLI_PATH \
	-e DOCKERCLI_VERSION \
	-e DOCKERCLI_REPOSITORY \
	-e DOCKERCLI_INTEGRATION_VERSION \
	-e DOCKERCLI_INTEGRATION_REPOSITORY \
	-e DOCKER_DEBUG \
	-e DOCKER_EXPERIMENTAL \
	-e DOCKER_GITCOMMIT \
	-e DOCKER_GRAPHDRIVER \
	-e DOCKER_LDFLAGS \
	-e DOCKER_PORT \
	-e DOCKER_REMAP_ROOT \
	-e DOCKER_ROOTLESS \
	-e DOCKER_STORAGE_OPTS \
	-e DOCKER_TEST_HOST \
	-e DOCKER_USERLANDPROXY \
	-e DOCKERD_ARGS \
	-e DELVE_PORT \
	-e GITHUB_ACTIONS \
	-e TEST_FORCE_VALIDATE \
	-e TEST_INTEGRATION_DIR \
	-e TEST_INTEGRATION_USE_SNAPSHOTTER \
	-e TEST_INTEGRATION_FAIL_FAST \
	-e TEST_SKIP_INTEGRATION \
	-e TEST_SKIP_INTEGRATION_CLI \
	-e TEST_IGNORE_CGROUP_CHECK \
	-e TESTCOVERAGE \
	-e TESTDEBUG \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TESTFLAGS_INTEGRATION \
	-e TESTFLAGS_INTEGRATION_CLI \
	-e TEST_FILTER \
	-e TIMEOUT \
	-e VALIDATE_REPO \
	-e VALIDATE_BRANCH \
	-e VALIDATE_ORIGIN_BRANCH \
	-e VERSION \
	-e PLATFORM \
	-e DEFAULT_PRODUCT_LICENSE \
	-e PRODUCT \
	-e PACKAGER_NAME \
	-e PAGER \
	-e GIT_PAGER \
	-e OTEL_EXPORTER_OTLP_ENDPOINT \
	-e OTEL_EXPORTER_OTLP_PROTOCOL \
	-e OTEL_SERVICE_NAME
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make BIND_DIR=. shell` or `make BIND_DIR= test`
# (default to no bind mount if DOCKER_HOST is set)
# note: BINDDIR is supported for backwards-compatibility here
BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,bundles))

# DOCKER_MOUNT can be overriden, but use at your own risk!
ifndef DOCKER_MOUNT
DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(CURDIR)/$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")
DOCKER_MOUNT := $(if $(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT):$(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT))

# This allows the test suite to be able to run without worrying about the underlying fs used by the container running the daemon (e.g. aufs-on-aufs), so long as the host running the container is running a supported fs.
# The volume will be cleaned up when the container is removed due to `--rm`.
# Note that `BIND_DIR` will already be set to `bundles` if `DOCKER_HOST` is not set (see above BIND_DIR line), in such case this will do nothing since `DOCKER_MOUNT` will already be set.
DOCKER_MOUNT := $(if $(DOCKER_MOUNT),$(DOCKER_MOUNT),-v /go/src/github.com/docker/docker/bundles) -v "$(CURDIR)/.git:/go/src/github.com/docker/docker/.git"

DOCKER_MOUNT_CACHE := -v docker-dev-cache:/root/.cache -v docker-mod-cache:/go/pkg/mod/
DOCKER_MOUNT_CLI := $(if $(DOCKER_CLI_PATH),-v $(shell dirname $(DOCKER_CLI_PATH)):/usr/local/cli,)
DOCKER_MOUNT_BASH_COMPLETION := $(if $(DOCKER_BASH_COMPLETION_PATH),-v $(shell dirname $(DOCKER_BASH_COMPLETION_PATH)):/usr/local/completion/bash,)
DOCKER_MOUNT := $(DOCKER_MOUNT) $(DOCKER_MOUNT_CACHE) $(DOCKER_MOUNT_CLI) $(DOCKER_MOUNT_BASH_COMPLETION)
endif # ifndef DOCKER_MOUNT

# This allows to set the docker-dev container name
DOCKER_CONTAINER_NAME := $(if $(CONTAINER_NAME),--name $(CONTAINER_NAME),)

DOCKER_IMAGE := docker-dev
DOCKER_PORT_FORWARD := $(if $(DOCKER_PORT),-p "$(DOCKER_PORT)",)
DELVE_PORT_FORWARD := $(if $(DELVE_PORT),-p "$(DELVE_PORT)",)

DOCKER_FLAGS := $(DOCKER) run --rm --privileged $(DOCKER_CONTAINER_NAME) $(DOCKER_ENVS) $(DOCKER_MOUNT) $(DOCKER_PORT_FORWARD) $(DELVE_PORT_FORWARD)

SWAGGER_DOCS_PORT ?= 9000

define \n


endef

# if this session isn't interactive, then we don't want to allocate a
# TTY, which would fail, but if it is interactive, we do want to attach
# so that the user can send e.g. ^C through.
INTERACTIVE := $(shell [ -t 0 ] && echo 1 || echo 0)
ifeq ($(INTERACTIVE), 1)
	DOCKER_FLAGS += -t
endif

# on GitHub Runners input device is not a TTY but we allocate a pseudo-one,
# otherwise keep STDIN open even if not attached if not a GitHub Runner.
ifeq ($(GITHUB_ACTIONS),true)
	DOCKER_FLAGS += -t
else
	DOCKER_FLAGS += -i
endif

DOCKER_RUN_DOCKER := $(DOCKER_FLAGS) "$(DOCKER_IMAGE)"

DOCKER_BUILD_ARGS += --build-arg=GO_VERSION
DOCKER_BUILD_ARGS += --build-arg=DOCKERCLI_VERSION
DOCKER_BUILD_ARGS += --build-arg=DOCKERCLI_REPOSITORY
DOCKER_BUILD_ARGS += --build-arg=DOCKERCLI_INTEGRATION_VERSION
DOCKER_BUILD_ARGS += --build-arg=DOCKERCLI_INTEGRATION_REPOSITORY
ifdef DOCKER_SYSTEMD
DOCKER_BUILD_ARGS += --build-arg=SYSTEMD=true
endif

BUILD_OPTS := ${DOCKER_BUILD_ARGS} ${DOCKER_BUILD_OPTS}
BUILD_CMD := $(BUILDX) build
BAKE_CMD := $(BUILDX) bake

default: binary

all: build ## validate all checks, build linux binaries, run all tests,\ncross build non-linux binaries, and generate archives
	$(DOCKER_RUN_DOCKER) bash -c 'hack/validate/default && hack/make.sh'

binary: bundles ## build statically linked linux binaries
	$(BAKE_CMD) binary

dynbinary: bundles ## build dynamically linked linux binaries
	$(BAKE_CMD) dynbinary

cross: bundles ## cross build the binaries
	$(BAKE_CMD) binary-cross

bundles:
	mkdir bundles

.PHONY: clean
clean: clean-cache

.PHONY: clean-cache
clean-cache: ## remove the docker volumes that are used for caching in the dev-container
	docker volume rm -f docker-dev-cache docker-mod-cache

help: ## this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

install: ## install the linux binaries
	KEEPBUNDLE=1 hack/make.sh install-binary

run: build ## run the docker daemon in a container
	$(DOCKER_RUN_DOCKER) sh -c "KEEPBUNDLE=1 hack/make.sh install-binary run"
 
.PHONY: build
ifeq ($(BIND_DIR), .)
build: shell_target := --target=dev-base
else
build: shell_target := --target=dev
endif
build: bundles
	$(BUILD_CMD) $(BUILD_OPTS) $(shell_target) --load -t "$(DOCKER_IMAGE)" .

shell: build  ## start a shell inside the build env
	$(DOCKER_RUN_DOCKER) bash

test: build test-unit ## run the unit, integration and docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration test-docker-py

test-docker-py: build ## run the docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-docker-py

test-integration-cli: test-integration ## (DEPRECATED) use test-integration

ifneq ($(and $(TEST_SKIP_INTEGRATION),$(TEST_SKIP_INTEGRATION_CLI)),)
test-integration:
	@echo Both integrations suites skipped per environment variables
else
test-integration: build ## run the integration tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration
endif

test-integration-flaky: build ## run the stress test for all new integration tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration-flaky

test-unit: build ## run the unit tests
	$(DOCKER_RUN_DOCKER) hack/test/unit

validate: build ## validate DCO, Seccomp profile generation, gofmt,\n./pkg/ isolation, golint, tests, tomls, go vet and vendor
	$(DOCKER_RUN_DOCKER) hack/validate/all

validate-generate-files:
	$(BUILD_CMD) --target "validate" \
		--output "type=cacheonly" \
		--file "./hack/dockerfiles/generate-files.Dockerfile" .

validate-%: build ## validate specific check
	$(DOCKER_RUN_DOCKER) hack/validate/$*

win: bundles ## cross build the binary for windows
	$(BAKE_CMD) --set *.platform=windows/amd64 binary

.PHONY: swagger-gen
swagger-gen:
	docker run --rm -v $(PWD):/go/src/github.com/docker/docker \
		-w /go/src/github.com/docker/docker \
		--entrypoint hack/generate-swagger-api.sh \
		-e GOPATH=/go \
		quay.io/goswagger/swagger:0.7.4

.PHONY: swagger-docs
swagger-docs: ## preview the API documentation
	@echo "API docs preview will be running at http://localhost:$(SWAGGER_DOCS_PORT)"
	@docker run --rm -v $(PWD)/api/swagger.yaml:/usr/share/nginx/html/swagger.yaml \
		-e 'REDOC_OPTIONS=hide-hostname="true" lazy-rendering' \
		-p $(SWAGGER_DOCS_PORT):80 \
		bfirsh/redoc:1.14.0

.PHONY: generate-files
generate-files:
	$(eval $@_TMP_OUT := $(shell mktemp -d -t moby-output.XXXXXXXXXX))
	@if [ -z "$($@_TMP_OUT)" ]; then \
		echo "Temp dir is not set"; \
		exit 1; \
	fi
	$(BUILD_CMD) --target "update" \
		--output "type=local,dest=$($@_TMP_OUT)" \
		--file "./hack/dockerfiles/generate-files.Dockerfile" .
	cp -R "$($@_TMP_OUT)"/. .
	rm -rf "$($@_TMP_OUT)"/*

=== vendor/github.com/cilium/ebpf/Makefile ===
# The development version of clang is distributed as the 'clang' binary,
# while stable/released versions have a version number attached.
# Pin the default clang to a stable version.
CLANG ?= clang-14
STRIP ?= llvm-strip-14
OBJCOPY ?= llvm-objcopy-14
CFLAGS := -O2 -g -Wall -Werror $(CFLAGS)

CI_KERNEL_URL ?= https://github.com/cilium/ci-kernels/raw/master/

# Obtain an absolute path to the directory of the Makefile.
# Assume the Makefile is in the root of the repository.
REPODIR := $(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))
UIDGID := $(shell stat -c '%u:%g' ${REPODIR})

# Prefer podman if installed, otherwise use docker.
# Note: Setting the var at runtime will always override.
CONTAINER_ENGINE ?= $(if $(shell command -v podman), podman, docker)
CONTAINER_RUN_ARGS ?= $(if $(filter ${CONTAINER_ENGINE}, podman), --log-driver=none, --user "${UIDGID}")

IMAGE := $(shell cat ${REPODIR}/testdata/docker/IMAGE)
VERSION := $(shell cat ${REPODIR}/testdata/docker/VERSION)


# clang <8 doesn't tag relocs properly (STT_NOTYPE)
# clang 9 is the first version emitting BTF
TARGETS := \
	testdata/loader-clang-7 \
	testdata/loader-clang-9 \
	testdata/loader-$(CLANG) \
	testdata/manyprogs \
	testdata/btf_map_init \
	testdata/invalid_map \
	testdata/raw_tracepoint \
	testdata/invalid_map_static \
	testdata/invalid_btf_map_init \
	testdata/strings \
	testdata/freplace \
	testdata/iproute2_map_compat \
	testdata/map_spin_lock \
	testdata/subprog_reloc \
	testdata/fwd_decl \
	testdata/kconfig \
	testdata/kconfig_config \
	testdata/kfunc \
	testdata/invalid-kfunc \
	testdata/kfunc-kmod \
	btf/testdata/relocs \
	btf/testdata/relocs_read \
	btf/testdata/relocs_read_tgt \
	cmd/bpf2go/testdata/minimal

.PHONY: all clean container-all container-shell generate

.DEFAULT_TARGET = container-all

# Build all ELF binaries using a containerized LLVM toolchain.
container-all:
	+${CONTAINER_ENGINE} run --rm -ti ${CONTAINER_RUN_ARGS} \
		-v "${REPODIR}":/ebpf -w /ebpf --env MAKEFLAGS \
		--env CFLAGS="-fdebug-prefix-map=/ebpf=." \
		--env HOME="/tmp" \
		"${IMAGE}:${VERSION}" \
		make all

# (debug) Drop the user into a shell inside the container as root.
container-shell:
	${CONTAINER_ENGINE} run --rm -ti \
		-v "${REPODIR}":/ebpf -w /ebpf \
		"${IMAGE}:${VERSION}"

clean:
	-$(RM) testdata/*.elf
	-$(RM) btf/testdata/*.elf

format:
	find . -type f -name "*.c" | xargs clang-format -i

all: format $(addsuffix -el.elf,$(TARGETS)) $(addsuffix -eb.elf,$(TARGETS)) generate
	ln -srf testdata/loader-$(CLANG)-el.elf testdata/loader-el.elf
	ln -srf testdata/loader-$(CLANG)-eb.elf testdata/loader-eb.elf

# $BPF_CLANG is used in go:generate invocations.
generate: export BPF_CLANG := $(CLANG)
generate: export BPF_CFLAGS := $(CFLAGS)
generate:
	go generate ./...

testdata/loader-%-el.elf: testdata/loader.c
	$* $(CFLAGS) -target bpfel -c $< -o $@
	$(STRIP) -g $@

testdata/loader-%-eb.elf: testdata/loader.c
	$* $(CFLAGS) -target bpfeb -c $< -o $@
	$(STRIP) -g $@

%-el.elf: %.c
	$(CLANG) $(CFLAGS) -target bpfel -c $< -o $@
	$(STRIP) -g $@

%-eb.elf : %.c
	$(CLANG) $(CFLAGS) -target bpfeb -c $< -o $@
	$(STRIP) -g $@

.PHONY: generate-btf
generate-btf: KERNEL_VERSION?=5.19
generate-btf:
	$(eval TMP := $(shell mktemp -d))
	curl -fL "$(CI_KERNEL_URL)/linux-$(KERNEL_VERSION).bz" -o "$(TMP)/bzImage"
	/lib/modules/$(uname -r)/build/scripts/extract-vmlinux "$(TMP)/bzImage" > "$(TMP)/vmlinux"
	$(OBJCOPY) --dump-section .BTF=/dev/stdout "$(TMP)/vmlinux" /dev/null | gzip > "btf/testdata/vmlinux.btf.gz"
	curl -fL "$(CI_KERNEL_URL)/linux-$(KERNEL_VERSION)-selftests-bpf.tgz" -o "$(TMP)/selftests.tgz"
	tar -xf "$(TMP)/selftests.tgz" --to-stdout tools/testing/selftests/bpf/bpf_testmod/bpf_testmod.ko | \
		$(OBJCOPY) --dump-section .BTF="btf/testdata/btf_testmod.btf" - /dev/null
	$(RM) -r "$(TMP)"

=== debian/changelog ===
docker.io-app (26.1.3-0ubuntu2) plucky; urgency=medium

  * SECURITY UPDATE: authz plugin bypass causes privilege escalation
    - debian/patches/CVE-2024-41110-1.patch: Authz plugin security fixes
      for 0-length content and path validation
    - debian/patches/CVE-2024-41110-2.patch: If url includes scheme,
      urlPath will drop hostname, which would not match the auth check
    - CVE-2024-41110

 -- Vyom Yadav <vyom.yadav@canonical.com>  Thu, 12 Dec 2024 17:32:57 +0530

docker.io-app (26.1.3-0ubuntu1) oracular; urgency=medium

  * New upstream release.
    - Allow runc to kill containers when confined to the runc profile in
      AppArmor version 4.0.0 and later.
  * d/helpers/build-manpages.sh: build manpages with Go 1.21.
  * d/manpages: update them all.
  * d/docker.io.docs: remove NOTICE file of a dependency removed from cli.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 04 Jun 2024 18:01:29 -0300

## docker.io-app 27.5.1

=== debian/changelog ===
docker.io-app (27.5.1-0ubuntu3~24.04.2) noble-security; urgency=medium

  * No-change rebuild to copy previous update to the security pocket.

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Mon, 02 Jun 2025 09:21:53 -0230

docker.io-app (27.5.1-0ubuntu3~24.04.1) noble; urgency=medium

  * Backport from plucky to noble (LP: #2085187)
  * d/control: build with golang 1.22 for consistency across the supported
    release
  * d/rules: add golang 1.22 to PATH
  * d/t/docker-in-lxd: workaround Apparmor/kernel bug (LP #2067900)
  * d/docker.io.postinst: notify when a reboot is required to reload the
    AppArmor profile (LP #2065423).

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 01 Apr 2025 11:11:56 -0300

docker.io-app (27.5.1-0ubuntu3) plucky; urgency=medium

  * d/control: set a version for the docker-cli Provides

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 25 Feb 2025 08:04:14 -0300

docker.io-app (27.5.1-0ubuntu2) plucky; urgency=medium

  * d/control: provides docker-cli (LP: #2099941)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 24 Feb 2025 17:53:24 -0300

docker.io-app (27.5.1-0ubuntu1) plucky; urgency=medium

  * New upstream version 27.5.1 (LP: #2085187)
  * d/control: build with golang 1.24 (LP: #2098661)
  * d/rules: add golang 1.24 to PATH
  * d/patches: drop patches for CVE-2024-41110. Fixed upstream
  * d/helpers/build-manpages.sh: build manpages with Go 1.24
  * d/manpages/*: update manpages for version 27.5.1
  * d/docker.io.docs: update NOTICE files

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 18 Feb 2025 09:30:29 -0300

=== debian/control ===
Source: docker.io-app
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: bash-completion,
               ca-certificates,
               cmake,
               debconf (>= 0.5),
               debhelper-compat (= 12),
               dh-apparmor,
               dh-exec,
               dh-golang,
               git,
               golang-1.22-go,
               libapparmor-dev,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libdevmapper-dev (>= 2:1.02.68~),
               libltdl-dev,
               libseccomp-dev,
               libsystemd-dev (>= 209~),
               pkg-config,
               po-debconf,
               procps,
               tzdata
Standards-Version: 4.6.2
Homepage: https://mobyproject.org/
Vcs-Git: https://github.com/canonical/docker.io-app.git
Vcs-Browser: https://github.com/canonical/docker.io-app

Package: docker.io
Architecture: any
Depends: adduser,
         containerd (>= 1.2.6-0ubuntu1~),
         iptables,
         ${misc:Depends},
         ${shlibs:Depends}
# Debian split the daemon and the docker binary into docker.io and docker-cli,
# respectively. Instead of splitting it here, let's add a Provides: docker-cli
# https://salsa.debian.org/ci-team/autopkgtest/-/merge_requests/399#note_543111
# LP: #2099941
Provides: docker-cli (= ${binary:Version})
Recommends: ca-certificates,
            git,
            pigz,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Suggests: aufs-tools,
          btrfs-progs,
          cgroupfs-mount | cgroup-lite,
          debootstrap,
          docker-buildx,
          docker-compose-v2,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export VERSION := $(DEB_VERSION_UPSTREAM)

export DOCKER_GITCOMMIT := $(DEB_VERSION)

export MANPAGES_VERSION := $(shell cat debian/manpages/upstream-version)

# Build with Golang 1.22
export PATH := /usr/lib/go-1.22/bin:$(PATH)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor seccomp selinux

ifneq (,$(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	NUMJOBS := $(patsubst parallel=%, %, $(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j '$(NUMJOBS)'
endif

override_dh_gencontrol:
	# if we're on Ubuntu, we need to Recommends: apparmor
	echo 'apparmor:Recommends=$(shell dpkg-vendor --is Ubuntu && echo apparmor)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker.io.substvars
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(DOCKER_BUILDTAGS)" \
		github.com/docker/docker/cmd/dockerd \
		github.com/docker/cli/cmd/docker \
		github.com/docker/docker/cmd/docker-proxy \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# set up GOPATH symlink farm
	# cli
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/cli' '$(OUR_GOPATH)/src/github.com/docker/cli'
	# engine
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/engine' '$(OUR_GOPATH)/src/github.com/docker/docker'

override_dh_auto_build: _check-manpages _build-tini _build-proxy _build-cli _build-engine
	@#

# several "supporting binaries" need to be built and installed
# (https://github.com/docker/docker-ce/tree/v19.03.6/components/engine/hack/dockerfile/install)

_build-tini: # (docker-init)
	mkdir -p tini/build
	cd tini/build \
		&& cmake .. \
		&& make tini-static

_build-proxy: # (from libnetwork)
	go build -o libnetwork/docker-proxy github.com/docker/docker/cmd/docker-proxy

_build-cli:
	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
		make -C cli \
			LDFLAGS='' \
			VERSION='$(VERSION)' \
			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
			dynbinary

_check-manpages:
ifeq ($(VERSION), $(MANPAGES_VERSION))
	@echo "Manpages are up-to-date"
else
	@echo "Manpages version does not match the upstream version."
	@echo "Please, run debian/helpers/build-manpages.sh"
	exit 1
endif

_build-engine:
	cd engine \
		&& PRODUCT=docker ./hack/make.sh dynbinary

# basic smoke test to ensure binaries built successfully
# (especially since their actual tests are *really* involved)
override_dh_auto_test:
	# tini
	./tini/build/tini-static --version
	# cli
	./cli/build/docker --version
	# engine
	./engine/bundles/dynbinary-daemon/dockerd --version

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

# "--no-start" because we have a debconf prompt to determine whether to restart during upgrades
# (which means we get to handle both "start" and "stop" ourselves too)
override_dh_installinit:
	dh_installinit --name=docker --no-start

override_dh_installsystemd:
	# We take care of determining whether the docker.io service should be
	# restarted during upgrades or not ourselves, based on the debconf
	# choice made by the user during installation.  For this reason, we
	# invoke dh_installsystemd with "--no-stop-on-upgrade" in order
	# to avoid indiscriminately stopping the service during upgrades.
	dh_installsystemd --name=docker --no-start -pdocker.io --no-stop-on-upgrade docker.service
	dh_installsystemd --name=docker --no-start -pdocker.io --no-stop-on-upgrade docker.socket

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80

override_dh_install:
	dh_install
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_clean:
	@# stop debhelper from doing "make clean"

override_dh_dwz:
	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
	# dh_dwz --no-dwz-multifile also does not work :)

%:
	dh $@ --with=bash-completion

=== debian/tests/control ===
Tests: basic-smoke
Depends: debian-archive-keyring, debootstrap, @
Restrictions: allow-stderr isolation-machine needs-root

Tests: docker-in-lxd
Depends: dctrl-tools, snapd
Restrictions: allow-stderr isolation-machine needs-root

## docker.io-app 28.2.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.0)
project (tini C)

# Config
set (tini_VERSION_MAJOR 0)
set (tini_VERSION_MINOR 19)
set (tini_VERSION_PATCH 0)

# Build options
option(MINIMAL "Disable argument parsing and verbose output" OFF)

if(MINIMAL)
	add_definitions(-DTINI_MINIMAL=1)
endif()

# Extract git version and dirty-ness
execute_process (
  COMMAND git --git-dir "${PROJECT_SOURCE_DIR}/.git" --work-tree "${PROJECT_SOURCE_DIR}" log -n 1 --date=local --pretty=format:%h
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  RESULT_VARIABLE git_version_check_ret
  OUTPUT_VARIABLE tini_VERSION_GIT
)

execute_process(
  COMMAND git --git-dir "${PROJECT_SOURCE_DIR}/.git" --work-tree "${PROJECT_SOURCE_DIR}" status --porcelain --untracked-files=no
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE git_dirty_check_out
)

if("${git_version_check_ret}" EQUAL 0)
  set(tini_VERSION_GIT " - git.${tini_VERSION_GIT}")
  if(NOT "${git_dirty_check_out}" STREQUAL "")
    set(tini_VERSION_GIT "${tini_VERSION_GIT}-dirty")
  endif()
else()
  set(tini_VERSION_GIT "")
endif()

# Flags
include(CheckCSourceCompiles)

check_c_source_compiles("
#ifndef _FORTIFY_SOURCE
#error \"Not defined: _FORTIFY_SOURCE\"
#endif
int main(void)                                                                                                              {
  return 0;
}
" HAS_BUILTIN_FORTIFY)

# Flags
if(NOT HAS_BUILTIN_FORTIFY)
	add_definitions(-D_FORTIFY_SOURCE=2)
endif()

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Werror -Wextra -Wall -pedantic-errors -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat")
set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-Bsymbolic-functions -Wl,-z,relro -Wl,-s")

# Build

configure_file (
	"${PROJECT_SOURCE_DIR}/src/tiniConfig.h.in"
	"${PROJECT_BINARY_DIR}/tiniConfig.h"
	@ONLY
)

configure_file (
	"${PROJECT_SOURCE_DIR}/tpl/README.md.in"
	"${PROJECT_SOURCE_DIR}/README.md"
	@ONLY
)

configure_file (
	"${PROJECT_SOURCE_DIR}/tpl/VERSION.in"
	"${PROJECT_BINARY_DIR}/VERSION"
	@ONLY
)


include_directories ("${PROJECT_BINARY_DIR}")

add_executable (tini src/tini.c)

add_executable (tini-static src/tini.c)
set_target_properties (tini-static PROPERTIES LINK_FLAGS "-Wl,--no-export-dynamic -static")

# Installation
install (TARGETS tini DESTINATION bin)
install (TARGETS tini-static DESTINATION bin)

# Packaging
include (InstallRequiredSystemLibraries)
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "A tiny but valid init process for containers")
set (CPACK_PACKAGE_VENDOR "Thomas Orozco")
set (CPACK_PACKAGE_CONTACT "thomas@orozco.fr")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set (CPACK_PACKAGE_VERSION_MAJOR "${tini_VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${tini_VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_PATCH "${tini_VERSION_PATCH}")
set (CPACK_PACKAGE_EXECUTABLES "${CMAKE_PROJECT_NAME}")
set (CPACK_PACKAGE_NAME "${CMAKE_PROJECT_NAME}")
set (CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}_${tini_VERSION_MAJOR}.${tini_VERSION_MINOR}.${tini_VERSION_PATCH}")
set (CPACK_PACKAGE_VERSION "${tini_VERSION_MAJOR}.${tini_VERSION_MINOR}.${tini_VERSION_PATCH}")

set (CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")  # TODO
set (CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.4)")

set (CPACK_RPM_PACKAGE_ARCHITECTURE "x86_64")

set (CPACK_GENERATOR "DEB" "RPM")

include (CPack)

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,5 @@
-.PHONY: all binary dynbinary build cross help install manpages run shell test test-docker-py test-integration test-unit validate validate-% win
-
 DOCKER ?= docker
 BUILDX ?= $(DOCKER) buildx
-
-# set the graph driver as the current graphdriver if not set
-DOCKER_GRAPHDRIVER := $(if $(DOCKER_GRAPHDRIVER),$(DOCKER_GRAPHDRIVER),$(shell docker info -f '{{ .Driver }}' 2>&1))
-export DOCKER_GRAPHDRIVER
 
 DOCKER_GITCOMMIT := $(shell git rev-parse HEAD)
 export DOCKER_GITCOMMIT
@@ -37,7 +31,6 @@
 	-e DOCKER_BUILD_OPTS \
 	-e DOCKER_BUILD_PKGS \
 	-e DOCKER_BUILDKIT \
-	-e DOCKER_BASH_COMPLETION_PATH \
 	-e DOCKER_CLI_PATH \
 	-e DOCKERCLI_VERSION \
 	-e DOCKERCLI_REPOSITORY \
@@ -56,6 +49,7 @@
 	-e DOCKER_USERLANDPROXY \
 	-e DOCKERD_ARGS \
 	-e DELVE_PORT \
+	-e FIREWALLD \
 	-e GITHUB_ACTIONS \
 	-e TEST_FORCE_VALIDATE \
 	-e TEST_INTEGRATION_DIR \
@@ -63,7 +57,6 @@
 	-e TEST_INTEGRATION_FAIL_FAST \
 	-e TEST_SKIP_INTEGRATION \
 	-e TEST_SKIP_INTEGRATION_CLI \
-	-e TEST_IGNORE_CGROUP_CHECK \
 	-e TESTCOVERAGE \
 	-e TESTDEBUG \
 	-e TESTDIRS \
@@ -90,11 +83,11 @@
 # to allow `make BIND_DIR=. shell` or `make BIND_DIR= test`
 # (default to no bind mount if DOCKER_HOST is set)
 # note: BINDDIR is supported for backwards-compatibility here
-BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,bundles))
-
-# DOCKER_MOUNT can be overriden, but use at your own risk!
+BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,.))
+
+# DOCKER_MOUNT can be overridden, but use at your own risk!
 ifndef DOCKER_MOUNT
-DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(CURDIR)/$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")
+DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")
 DOCKER_MOUNT := $(if $(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT):$(DOCKER_BINDDIR_MOUNT_OPTS),$(DOCKER_MOUNT))
 
 # This allows the test suite to be able to run without worrying about the underlying fs used by the container running the daemon (e.g. aufs-on-aufs), so long as the host running the container is running a supported fs.
@@ -104,8 +97,14 @@
 
 DOCKER_MOUNT_CACHE := -v docker-dev-cache:/root/.cache -v docker-mod-cache:/go/pkg/mod/
 DOCKER_MOUNT_CLI := $(if $(DOCKER_CLI_PATH),-v $(shell dirname $(DOCKER_CLI_PATH)):/usr/local/cli,)
-DOCKER_MOUNT_BASH_COMPLETION := $(if $(DOCKER_BASH_COMPLETION_PATH),-v $(shell dirname $(DOCKER_BASH_COMPLETION_PATH)):/usr/local/completion/bash,)
-DOCKER_MOUNT := $(DOCKER_MOUNT) $(DOCKER_MOUNT_CACHE) $(DOCKER_MOUNT_CLI) $(DOCKER_MOUNT_BASH_COMPLETION)
+
+ifdef BIND_GIT
+	# Gets the common .git directory (even from inside a git worktree)
+	GITDIR := $(shell realpath $(shell git rev-parse --git-common-dir))
+	MOUNT_GITDIR := $(if $(GITDIR),-v "$(GITDIR):$(GITDIR)")
+endif
+
+DOCKER_MOUNT := $(DOCKER_MOUNT) $(DOCKER_MOUNT_CACHE) $(DOCKER_MOUNT_CLI) $(DOCKER_MOUNT_BASH_COMPLETION) $(MOUNT_GITDIR)
 endif # ifndef DOCKER_MOUNT
 
 # This allows to set the docker-dev container name
@@ -150,6 +149,9 @@
 ifdef DOCKER_SYSTEMD
 DOCKER_BUILD_ARGS += --build-arg=SYSTEMD=true
 endif
+ifdef FIREWALLD
+DOCKER_BUILD_ARGS += --build-arg=FIREWALLD=true
+endif
 
 BUILD_OPTS := ${DOCKER_BUILD_ARGS} ${DOCKER_BUILD_OPTS}
 BUILD_CMD := $(BUILDX) build
@@ -157,15 +159,19 @@
 
 default: binary
 
+.PHONY: all
 all: build ## validate all checks, build linux binaries, run all tests,\ncross build non-linux binaries, and generate archives
 	$(DOCKER_RUN_DOCKER) bash -c 'hack/validate/default && hack/make.sh'
 
+.PHONY: binary
 binary: bundles ## build statically linked linux binaries
 	$(BAKE_CMD) binary
 
+.PHONY: dynbinary
 dynbinary: bundles ## build dynamically linked linux binaries
 	$(BAKE_CMD) dynbinary
 
+.PHONY: cross
 cross: bundles ## cross build the binaries
 	$(BAKE_CMD) binary-cross
 
@@ -179,12 +185,15 @@
 clean-cache: ## remove the docker volumes that are used for caching in the dev-container
 	docker volume rm -f docker-dev-cache docker-mod-cache
 
+.PHONY: help
 help: ## this help
 	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)
 
+.PHONY: install
 install: ## install the linux binaries
 	KEEPBUNDLE=1 hack/make.sh install-binary
 
+.PHONY: run
 run: build ## run the docker daemon in a container
 	$(DOCKER_RUN_DOCKER) sh -c "KEEPBUNDLE=1 hack/make.sh install-binary run"
  
@@ -197,17 +206,22 @@
 build: bundles
 	$(BUILD_CMD) $(BUILD_OPTS) $(shell_target) --load -t "$(DOCKER_IMAGE)" .
 
+.PHONY: shell
 shell: build  ## start a shell inside the build env
 	$(DOCKER_RUN_DOCKER) bash
 
+.PHONY: test
 test: build test-unit ## run the unit, integration and docker-py tests
 	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration test-docker-py
 
+.PHONY: test-docker-py
 test-docker-py: build ## run the docker-py tests
 	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-docker-py
 
+.PHONY: test-integration-cli
 test-integration-cli: test-integration ## (DEPRECATED) use test-integration
 
+.PHONY: test-integration
 ifneq ($(and $(TEST_SKIP_INTEGRATION),$(TEST_SKIP_INTEGRATION_CLI)),)
 test-integration:
 	@echo Both integrations suites skipped per environment variables
@@ -216,23 +230,29 @@
 	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration
 endif
 
+.PHONY: test-integration-flaky
 test-integration-flaky: build ## run the stress test for all new integration tests
 	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-integration-flaky
 
+.PHONY: test-unit
 test-unit: build ## run the unit tests
 	$(DOCKER_RUN_DOCKER) hack/test/unit
 
+.PHONY: validate
 validate: build ## validate DCO, Seccomp profile generation, gofmt,\n./pkg/ isolation, golint, tests, tomls, go vet and vendor
 	$(DOCKER_RUN_DOCKER) hack/validate/all
 
+.PHONY: validate-generate-files
 validate-generate-files:
 	$(BUILD_CMD) --target "validate" \
 		--output "type=cacheonly" \
 		--file "./hack/dockerfiles/generate-files.Dockerfile" .
 
+.PHONY: validate-%
 validate-%: build ## validate specific check
 	$(DOCKER_RUN_DOCKER) hack/validate/$*
 
+.PHONY: win
 win: bundles ## cross build the binary for windows
 	$(BAKE_CMD) --set *.platform=windows/amd64 binary

=== vendor/github.com/package-url/packageurl-go/Makefile ===
.PHONY: test clean lint

test:
	go test -v -cover ./...

lint:
	go get -u golang.org/x/lint/golint
	golint -set_exit_status

=== debian/changelog ===
docker.io-app (28.2.2-0ubuntu1~25.04.1) plucky; urgency=medium

  * Backport from questing to plucky (LP: #2112523)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 09 Sep 2025 21:35:07 -0300

docker.io-app (28.2.2-0ubuntu1) questing; urgency=medium

  * New upstream version 28.2.2
  * d/h/build-manpages.sh: adjust manpage build script to upstream changes
  * d/manpages/*: update manpages for version 28.2.2
  * d/docker.io.docs: update NOTICE files
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 17 Jun 2025 14:51:15 -0300

docker.io-app (27.5.1-0ubuntu4) questing; urgency=medium

  * d/control: conflicts/replaces podman-docker (LP: #2037905)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 03 Jun 2025 13:35:31 -0300

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                dh-exec,
                dh-golang,
                git,
-               golang-1.22-go,
+               golang-1.24-go,
                libapparmor-dev,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libdevmapper-dev (>= 2:1.02.68~),
@@ -34,6 +34,9 @@
          iptables,
          ${misc:Depends},
          ${shlibs:Depends}
+# podman-docker provides an alternative docker implementation
+Conflicts: podman-docker
+Replaces: podman-docker
 # Debian split the daemon and the docker binary into docker.io and docker-cli,
 # respectively. Instead of splitting it here, let's add a Provides: docker-cli
 # https://salsa.debian.org/ci-team/autopkgtest/-/merge_requests/399#note_543111

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,8 @@
 
 export MANPAGES_VERSION := $(shell cat debian/manpages/upstream-version)
 
-# Build with Golang 1.22
-export PATH := /usr/lib/go-1.22/bin:$(PATH)
+# Build with Golang 1.24
+export PATH := /usr/lib/go-1.24/bin:$(PATH)
 
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 OUR_GOPATH := $(CURDIR)/.gopath

## docker.io-app 29.1.2

=== Makefile ===
--- 
+++ 
@@ -38,8 +38,10 @@
 	-e DOCKERCLI_INTEGRATION_REPOSITORY \
 	-e DOCKER_DEBUG \
 	-e DOCKER_EXPERIMENTAL \
+	-e DOCKER_FIREWALL_BACKEND \
 	-e DOCKER_GITCOMMIT \
 	-e DOCKER_GRAPHDRIVER \
+	-e DOCKER_IGNORE_BR_NETFILTER_ERROR \
 	-e DOCKER_LDFLAGS \
 	-e DOCKER_PORT \
 	-e DOCKER_REMAP_ROOT \
@@ -53,7 +55,7 @@
 	-e GITHUB_ACTIONS \
 	-e TEST_FORCE_VALIDATE \
 	-e TEST_INTEGRATION_DIR \
-	-e TEST_INTEGRATION_USE_SNAPSHOTTER \
+	-e TEST_INTEGRATION_USE_GRAPHDRIVER \
 	-e TEST_INTEGRATION_FAIL_FAST \
 	-e TEST_SKIP_INTEGRATION \
 	-e TEST_SKIP_INTEGRATION_CLI \
@@ -203,7 +205,7 @@
 else
 build: shell_target := --target=dev
 endif
-build: bundles
+build: validate-bind-dir bundles
 	$(BUILD_CMD) $(BUILD_OPTS) $(shell_target) --load -t "$(DOCKER_IMAGE)" .
 
 .PHONY: shell
@@ -284,3 +286,10 @@
 		--file "./hack/dockerfiles/generate-files.Dockerfile" .
 	cp -R "$($@_TMP_OUT)"/. .
 	rm -rf "$($@_TMP_OUT)"/*
+
+.PHONY: validate-bind-dir
+validate-bind-dir:
+	@case "$(BIND_DIR)" in \
+		".."*|"/"*) echo "Make needs to be run from the project-root directory, with BIND_DIR set to \".\" or a subdir"; \
+		exit 1 ;; \
+	esac

=== debian/changelog ===
docker.io-app (29.1.2-0ubuntu1) resolute; urgency=medium

  * New upstream version 29.1.2
  * d/watch: accept new upstream tarball format
  * d/h/tini-upstream-version.sh: accept new upstream URL format
  * d/get-orig-source.sh: accept new upstream paths
  * d/manpages/*: update manpages for version 29.1.2
  * d/extra/vendor: vendorize docker-trust dependencies
  * d/copyright: update copyright data
  * d/control: B-D on libnftables-dev
  * d/s/include-binaries: allow vendorized code binary files
  * d/docker.io.docs: update NOTICE files
  * d/docker.io.install: install new docker-trust plugin
  * d/docker.io.lintian-overrides: remove obsolete lintian overrides
  * d/s/lintian-overrides: suppress non-relevant lintian warnings
  * d/rules:
    - Use moby/moby namespace
    - Build docker-trust plugin
  * d/t/docker-in-lxd: workaround cloud-init bug (LP: #2131809)

 -- Athos Ribeiro <athos@ubuntu.com>  Fri, 12 Dec 2025 10:35:58 -0300

=== debian/rules ===
--- 
+++ 
@@ -36,9 +36,9 @@
 	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
 	DH_GOLANG_BUILDPKG=' \
 		-tags "$(DOCKER_BUILDTAGS)" \
-		github.com/docker/docker/cmd/dockerd \
+		github.com/moby/moby/v2/cmd/dockerd \
 		github.com/docker/cli/cmd/docker \
-		github.com/docker/docker/cmd/docker-proxy \
+		github.com/moby/moby/v2/cmd/docker-proxy \
 	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
 	dh_gencontrol
 
@@ -48,10 +48,12 @@
 	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
 	ln -sfT '$(CURDIR)/cli' '$(OUR_GOPATH)/src/github.com/docker/cli'
 	# engine
-	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
-	ln -sfT '$(CURDIR)/engine' '$(OUR_GOPATH)/src/github.com/docker/docker'
+	mkdir -p '$(OUR_GOPATH)/src/github.com/moby/moby'
+	ln -sfT '$(CURDIR)/engine' '$(OUR_GOPATH)/src/github.com/moby/moby/v2'
+	# vendorize docker-trust dependencies
+	ln -sfT '$(CURDIR)/debian/extra/vendor' '$(CURDIR)/cli/cmd/docker-trust/vendor'
 
-override_dh_auto_build: _check-manpages _build-tini _build-proxy _build-cli _build-engine
+override_dh_auto_build: _check-manpages _build-tini _build-proxy _build-cli _build-engine _build-trust-plugin
 	@#
 
 # several "supporting binaries" need to be built and installed
@@ -64,7 +66,7 @@
 		&& make tini-static
 
 _build-proxy: # (from libnetwork)
-	go build -o libnetwork/docker-proxy github.com/docker/docker/cmd/docker-proxy
+	go build -o libnetwork/docker-proxy github.com/moby/moby/v2/cmd/docker-proxy
 
 _build-cli:
 	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
@@ -73,6 +75,14 @@
 			VERSION='$(VERSION)' \
 			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
 			dynbinary
+
+_build-trust-plugin:
+	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
+		make -C cli \
+			LDFLAGS='' \
+			VERSION='$(VERSION)' \
+			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
+			trust-plugin
 
 _check-manpages:
 ifeq ($(VERSION), $(MANPAGES_VERSION))
@@ -96,6 +106,8 @@
 	./cli/build/docker --version
 	# engine
 	./engine/bundles/dynbinary-daemon/dockerd --version
+	# docker-trust plugin (no version command)
+	cli/build/docker-trust --help
 
 override_dh_auto_install:
 	# we use dh_install / dh-exec for installing files where they need to be
@@ -127,6 +139,7 @@
 
 override_dh_auto_clean:
 	@# stop debhelper from doing "make clean"
+	rm -rf $(CURDIR)/cli/cmd/docker-trust/vendor
 
 override_dh_dwz:
 	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"

=== debian/watch ===
version=4

opts="\
dversionmangle=s/[+~](debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:docker-)?v?@ANY_VERSION@/moby-$1.tar.gz/,\
downloadurlmangle=s/api\.github\.com\/repos\/moby\/moby\/tarball\/(.*)/github.com\/moby\/moby\/archive\/refs\/tags\/$1.tar.gz/,\
searchmode=plain,\
" https://api.github.com/repos/moby/moby/releases?per_page=50 \
  https://api.github.com/repos/moby/moby/tarball/(?:docker-)?v?@ANY_VERSION@ \
  debian ./debian/get-orig-source.sh

## docker.io-app 29.1.3

=== debian/changelog ===
docker.io-app (29.1.3-0ubuntu1) resolute; urgency=medium

  * New upstream version 29.1.3
  * d/manpages/*: update manpages for version 29.1.3
  * d/docker.io.docs: update NOTICE files

 -- Athos Ribeiro <athos@ubuntu.com>  Tue, 06 Jan 2026 14:14:59 -0300

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libdevmapper-dev (>= 2:1.02.68~),
                libltdl-dev,
+               libnftables-dev,
                libseccomp-dev,
                libsystemd-dev (>= 209~),
                pkg-config,
